/*
 * $Header: /cvsroot/jdbforms/dbforms/src/org/dbforms/config/Interceptor.java,v 1.9 2004/10/23 13:35:38 hkollmann Exp $
 * $Revision: 1.9 $
 * $Date: 2004/10/23 13:35:38 $
 *
 * DbForms - a Rapid Application Development Framework
 * Copyright (C) 2001 Joachim Peer <joepeer@excite.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

package org.dbforms.config;

import java.util.HashMap;
import java.util.Map;



/**
 * <p>
 * This class holds XML config data defining interceptors for tables. compare
 * org.dbforms.event.DbEventInterceptor
 * </p>
 *
 * @author Joachim Peer
 */
public class Interceptor implements java.io.Serializable {
   // params may contain configuration data for the interceptor
   private Map    params;
   private String className;

   /**
    * Creates a new Interceptor object.
    */
   public Interceptor() {
      params = new HashMap();
   }

   /**
    * sets the name of the interceptor class to be invoked during runtime
    *
    * @param className - name of the Interceptor class
    */
   public void setClassName(String className) {
      this.className = className;
   }


   /**
    * returns the name of the interceptor class
    *
    * @return the name of the interceptor class
    */
   public String getClassName() {
      return className;
   }


   /**
    * DOCUMENT ME!
    *
    * @return DOCUMENT ME!
    */
   public Map getParameterMap() {
      return params;
   }


   /**
    * DOCUMENT ME!
    *
    * @param name DOCUMENT ME!
    * @param value DOCUMENT ME!
    */
   public void addParam(String name,
                        String value) {
      params.put(name, value);
   }
}
