/*
 * $Header: /cvsroot/jdbforms/dbforms/src/org/dbforms/devgui/WebAppPanel.java,v 1.7 2004/08/18 12:25:57 hkollmann Exp $
 * $Revision: 1.7 $
 * $Date: 2004/08/18 12:25:57 $
 *
 * DbForms - a Rapid Application Development Framework
 * Copyright (C) 2001 Joachim Peer <joepeer@excite.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

/*
 * WebAppPanel.java
 *
 * Created on 26. April 2001, 15:42
 */
package org.dbforms.devgui;

import java.awt.*;
import java.awt.event.*;

import java.io.*;

import javax.swing.*;



/**
 * DOCUMENT ME!
 *
 * @author Administrator
 * @version
 */
public class WebAppPanel extends PropertyPanel implements ActionListener {
   private JButton b_browseApp;
   private JButton b_chooseRoot;

   // GUI Variables declaration
   private JLabel jLabel1;

   // GUI Variables declaration
   private JLabel     jLabel2;
   private JTextField tf_webAppRoot;
   private JTextField tf_webAppURL;

   /**
    * Creates new form WebAppPanel
    *
    * @param parent DOCUMENT ME!
    */
   public WebAppPanel(DevGui parent) {
      super(parent.getProjectData());
      initComponents();
      doLayout();
   }

   /**
    * DOCUMENT ME!
    *
    * @param projectData DOCUMENT ME!
    */
   public void setNewProjectData(ProjectData projectData) {
      this.projectData = projectData;

      tf_webAppRoot.setText(projectData.getProperty("webAppRoot"));
      tf_webAppURL.setText(projectData.getProperty("webAppURL"));
   }


   /**
    * DOCUMENT ME!
    *
    * @param ev DOCUMENT ME!
    */
   public void actionPerformed(ActionEvent ev) {
      if (ev.getSource() == b_chooseRoot) {
         File dlgFile = new File(projectData.getProperty("webAppRoot"));

         if (!dlgFile.exists()) {
            dlgFile = null;
         }

         JFileChooser dlg_fileChooser = new JFileChooser(dlgFile);
         dlg_fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

         dlg_fileChooser.setVisible(true);

         int returnVal = dlg_fileChooser.showOpenDialog(this);

         if (returnVal == JFileChooser.APPROVE_OPTION) {
            tf_webAppRoot.setText(dlg_fileChooser.getSelectedFile().getAbsolutePath());
            tf_webAppRoot.grabFocus();
         }
      } else if (ev.getSource() == b_browseApp) {
         System.out.println("##");

         String webAppURL = projectData.getProperty("webAppURL");

         try {
            BrowserTool.openURL(webAppURL);
         } catch (IOException ioe) {
            showExceptionDialog(ioe);
         }
      }
   }


   /**
    * This method is called from within the constructor to initialize the form.
    * WARNING: Do NOT modify this code. The content of this method is always
    * regenerated by the FormEditor.
    */
   private void initComponents() { //GEN-BEGIN:initComponents
      setLayout(new BorderLayout());

      JPanel panel_top = new JPanel();
      panel_top.setLayout(new GridLayout(2, 3));
      add(BorderLayout.NORTH, panel_top);

      jLabel1 = new javax.swing.JLabel();
      jLabel1.setText("Location of Webapp");
      jLabel1.setToolTipText("the location of root directory of your web app");
      panel_top.add(jLabel1);

      tf_webAppRoot = new JTextField();
      addAFocusListener(tf_webAppRoot, "webAppRoot");
      panel_top.add(tf_webAppRoot);

      b_chooseRoot = new JButton("change dir...");
      b_chooseRoot.addActionListener(this);
      b_chooseRoot.setToolTipText("Choose the local root directory of your web application.");
      panel_top.add(b_chooseRoot);

      jLabel2 = new javax.swing.JLabel();
      jLabel2.setText("Web-URL of Webapp");
      panel_top.add(jLabel2);

      tf_webAppURL = new JTextField("http://127.0.0.1:8080/yourApp");
      addAFocusListener(tf_webAppURL, "webAppURL");
      panel_top.add(tf_webAppURL);

      b_browseApp = new JButton("view in browser...");
      b_chooseRoot.setToolTipText("Test the application. Web server must be running!");
      b_browseApp.addActionListener(this);
      panel_top.add(b_browseApp);
   }
}
